### Sample source file for Time Series course
### Yan Liu, 2018/11/29
### Large sample dist

# set working directory
wd <- setwd("D:/WHU/Under/TS18/R")

## Law of large number
sT  <- 20100
muh <- rep(0, sT)
X   <- runif(sT)
for (i in 1:sT){
  muh[i] <- mean(X[1:i])
}
plot(muh[101 : sT], type = "p", col = "blue",
     xlab = "", ylab = "",
     main = "Recursive sample mean")
abline(h = 0.5, col = "red")

## Central limit theorem
sT  <- 500
sN  <- 1000
muh <- rep(0, sN)
sgh <- rep(0, sN)
xi  <- rep(0, sN)
for (i in 1:sN){
  X <- runif(sT)
  muh[i] <- mean(X)
  sgh[i] <- sd(X) / sqrt(sT)
  xi[i]  <- (muh[i] - 0.5) / sgh[i]
}
hist(xi, breaks = 40, freq = FALSE)
xfit <- seq(min(xi), max(xi), length = 100)
yfit <- dnorm(xfit)
lines(xfit, yfit, col = "blue", lwd = 2)
box()

# compare sample mean sd estimators
plot(sgh, type = "p", col = "blue",
     xlab = "", ylab = "",
     main = "Simulation of sample mean")
abline(h = sd(muh), col = "red")
abline(h = mean(sgh), col = "green")
legend(x = "topleft", inset = 0.03, 
       legend = c("sig_h", "sd(mu_h)", "mean(sig_h)"), 
       bty = "o",
       lty = c(NA,1,1), 
       pch = c(1,NA,NA), 
       col = c("blue", "red", "green"), 
       horiz = T)